%%
%% conclusion.tex
%% $Id: conclusion.tex,v 1.22 2003-03-09 11:59:40 baurma Exp $
%%

\chapter{Conclusions}

\label{ch:conclusion}

A conceptual model for deterministic replay of multi-threaded Java
applications was developed. The necessary bytecode 
transformations for instrumentation were presented. Calls to an 
intermediary replayer are inserted into the program only where 
thread changes occurred in the original program. The replayer then performs 
scheduling according to this execution trace by blocking and unblocking
threads at runtime. Existing calls that imply a thread change are 
replaced or removed to avoid side-effects during replay. The model can 
handle all thread-related events with the exception of thread groups. 
A generic representation for an execution trace has been devised. Thread 
schedules conforming to this standard are read both at the time of 
instrumentation and during replay. 

The possibility to write class files, a facility for instrumenting byte 
code, and a parser to read text files with thread schedules to be replayed
have been implemented. The existing class loader was extended to support 
more class file attributes. The floating point wrapper objects were improved 
by adding support for special values. Two libraries with a broad 
variety of instrumentation functions were added to the \JNuke framework. 

A \jreplay application using all these extensions to enforce a given
thread schedule in a program was developed. It allows automatic
instrumentation of multi-threaded programs by detecting and 
instrumenting the class files of an application.

Simple experiments were made to verify the replay model. The
required thread schedules were manually produced. The results show that
instrumenting Java bytecode allows deterministic replay on any virtual 
machine conforming to the standards by Sun, including third party 
debuggers whose source code is not available. This is an advantage
compared to other replay solutions that rely on customized virtual
machines or particular library substitutes.

Using bytecode instrumentation to turn nondeterministic into 
deterministic programs can help reducing the required number of 
executions to fix concurrency-related errors in multithreaded programs. 
